ITPub博客

首页 > 移动开发 > ANDROID > Android 面试常见 - 二分查找算法题

Android 面试常见 - 二分查找算法题

原创 ANDROID 作者:yilian 时间:2019-11-13 13:57:23 0 删除 编辑



前言

“剁手”双十一,老板不给涨工资怎么办?那就只有跳槽涨工资了。

在面试的过程中,有时候难免会碰到一些算法题目。今天,为大家整理了二分查找常见的算法题。

主要包括以下三点

  1. 旋转数组中的最小数字
  2. 在旋转数组中查找某个数
  3. 排序数组中某个数的出现次数

旋转数组的最小数字

题目:把一个数组最开始的若干个元素搬到数组的末尾,我们称之为数组的旋转。

输入一个递增排序的数组的一个旋转,输出旋转数组的最小元素。例如数组{3,4,5,1,2}为{1,2,3,4,5}的一个旋转,该数组的最小值为1.

实现数组的旋转见左旋转字符串。

解题思路

和二分查找法一样,用两个指针分别指向数组的第一个元素和最后一个元素。

我们注意到旋转之后的数组实际上可以划分为两个排序的子数组,而且前面的子数组的元素都大于或者等于后面子数组的元素。

我们还可以注意到最小的元素刚好是这两个子数组的分界线。我们试着用二元查找法的思路在寻找这个最小的元素。

首先我们用两个指针,分别指向数组的第一个元素和最后一个元素。按照题目旋转的规则,第一个元素应该是大于或者等于最后一个元素的(这其实不完全对,还有特例。后面再讨论特例)。



接着我们得到处在数组中间的元素。如果该中间元素位于前面的递增子数组,那么它应该大于或者等于第一个指针指向的元素。

此时数组中最小的元素应该位于该中间 元素的后面。我们可以把第一指针指向该中间元素,这样可以缩小寻找的范围。

同样,如果中间元素位于后面的递增子数组,那么它应该小于或者等于第二个指针指 向的元素。

此时该数组中最小的元素应该位于该中间元素的前面。我们可以把第二个指针指向该中间元素,这样同样可以缩小寻找的范围。我们接着再用更新之后的 两个指针,去得到和比较新的中间元素,循环下去。


按照上述的思路,我们的第一个指针总是指向前面递增数组的元素,而第二个指针总是指向后面递增数组的元素。

最后第一个指针将指向前面子数组的最后一个元素, 而第二个指针会指向后面子数组的第一个元素。也就是它们最终会指向两个相邻的元素,而第二个指针指向的刚好是最小的元素。这就是循环结束的条件。

核心实现代码:



注意:当两个指针指向的数字及他们中间的数字三者相同的时候,我们无法判断中间的数字是位于前面的字数组还是后面的子数组中,也就无法移动两个指针来缩小查找的范围。此时,我们不得不采用顺序查找的方法。

2 旋转数组中查找某个数字

要求:一个没有重复元素的旋转数组(它对应的原数组是有序的),求给定元素在旋转数组内的下标(不存在的返回-1)。

例如

有序数组为{0,1,2,4,5,6,7},它的一个旋转数组为{4,5,6,7,0,1,2}。

元素6在旋转数组内,返回2
元素3不在旋转数组内,返回-1

分析

遍历一遍,可以轻松搞定,时间复杂度为O(n),因为是有序数组旋转得到,这样做肯定不是最优解。有序,本能反映用二分查找,举个例子看看特点
可以看出中间位置两段起码有一个是有序的(不是左边,就是右边),那么就可以在有序的范围内使用二分查找;如果不再有序范围内,就到另一半去找。

参考代码



扩展

边的有求是没有重复的元素,现在稍微扩展下,可以有重复的元素,其他的要求不变。

思路:大致思路与原来相同,这是需要比较A[beg] 与 A[mid]的关系



3 数字在排序数组中的出现次数


看完这些感觉怎么样,想要面试的程序员,可以多看看算法,直通bat的问题和源码可以学习一下


来自 “ ITPUB博客 ” ,链接:https://blog.itpub.net/69952849/viewspace-2663874/ ,如需转载,请注明出处,否则将追究法律责任。

请登录后发表评论 登录
全部评论
人生的长跑中,跑得最远的人,可能不是跑得最快的人,而是规划了最佳行程的人 Android学习也是如此,分享Android学习内容、面试精选等,关注我,需要学习计划大纲和学习内容:xx13414521

注册时间:2019-11-05

  • 博文量
    175
  • 访问量
    178549